6 # Build LLVM the "Apple way".
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 # FIXME: HOSTS is not used in this script. Use it or Remove it.
15 # The second parameter is a space-separated list of the architectures the
16 # compilers will generate code for. If the current machine isn't in the list, a
17 # compiler for it will get built anyway, but won't be installed.
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
28 # The fifth parameter is the place where the compiler will be copied once it's
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
45 # The nineth parameter is the version number of the submission, e.g. 1007.
46 LLVM_SUBMIT_VERSION
="$9"
48 # The tenth parameter is the subversion number of the submission, e.g. 03.
49 LLVM_SUBMIT_SUBVERSION
="${10}"
51 # The current working directory is where the build will happen. It may already
52 # contain a partial result of an interrupted build, in which case this script
53 # will continue where it left off.
56 DARWIN_VERS
=`uname -r | sed 's/\..*//'`
57 echo DARWIN_VERS
= $DARWIN_VERS
59 # If the user has CC set in their environment unset it now
62 if [ "x$RC_ProjectName" = "xllvmCore_Embedded" ]; then
63 DT_HOME
=$DEST_DIR/Developer
/Platforms
/iPhoneOS.platform
/Developer
/usr
64 DEST_ROOT
="/Developer/Platforms/iPhoneOS.platform/Developer$DEST_ROOT"
66 DT_HOME
=$DEST_DIR/Developer
/usr
67 DEST_ROOT
="/Developer$DEST_ROOT"
69 if [ "x$DEVELOPER_BIN" != "x" ]; then
70 if [ "x$RC_ProjectName" = "xllvmCore_Embedded" ]; then
71 DT_HOME
=$DEST_DIR/Developer
/Platforms
/iPhoneOS.platform
/$DEVELOPER_DIR/usr
73 DT_HOME
=$DEST_DIR/$DEVELOPER_DIR/usr
75 DEST_ROOT
="/$DEVELOPER_DIR$DEST_ROOT"
78 ################################################################################
81 # Create the source tree we'll actually use to build, deleting
82 # tcl since it doesn't actually build properly in a cross environment
83 # and we don't really need it.
85 rm -rf $SRC_DIR ||
exit 1
86 mkdir
$SRC_DIR ||
exit 1
87 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ ||
exit 1
89 # Build the LLVM tree universal.
90 mkdir
-p $DIR/obj-llvm ||
exit 1
91 cd $DIR/obj-llvm ||
exit 1
93 if [ \
! -f Makefile.config
]; then
94 $SRC_DIR/configure
--prefix=$DT_HOME/local \
95 --enable-targets=arm
,x86
,powerpc
,cbe \
96 --enable-assertions=$LLVM_ASSERTIONS \
97 --enable-optimized=$LLVM_OPTIMIZED \
102 SUBVERSION
=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
104 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
105 LLVM_SUBMIT_SUBVERSION
=`printf "%02d" $SUBVERSION`
106 RC_ProjectSourceVersion
=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
107 LLVM_SUBMIT_VERSION
=$RC_ProjectSourceVersion
110 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
111 LLVM_VERSION
="$LLVM_SUBMIT_VERSION"
113 LLVM_VERSION
="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
116 GCC_VER
=`cc --version 2>/dev/null | sed 1q`
118 if echo "$GCC_VER" |
grep GCC
> /dev
/null
; then
119 GCC_VER
=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
120 MAJ_VER
=`echo $GCC_VER | sed 's/\..*//'`
121 MIN_VER
=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
126 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
127 # already has parallelism and we don't want to make the builders hit swap by
128 # firing off too many gccs at the same time.
129 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
130 # Figure out how many make processes to run.
131 SYSCTL
=`sysctl -n hw.activecpu`
133 # hw.activecpu only available in 10.2.6 and later
134 if [ -z "$SYSCTL" ]; then
135 SYSCTL
=`sysctl -n hw.ncpu`
138 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
139 # Builders can default to 2, since even if they are single processor,
140 # nothing else is running on the machine.
141 if [ -z "$SYSCTL" ]; then
145 JOBS_FLAG
="-j $SYSCTL"
148 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL
=1 UNIVERSAL_ARCH
="$TARGETS" \
150 LLVM_SUBMIT_VERSION
=$LLVM_SUBMIT_VERSION \
151 LLVM_SUBMIT_SUBVERSION
=$LLVM_SUBMIT_SUBVERSION \
152 CXXFLAGS
="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
155 if ! test $?
== 0 ; then
156 echo "error: LLVM 'make' failed!"
160 ################################################################################
161 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
162 # $DEST_DIR, with occasional 'lipo' commands.
164 cd $DEST_DIR ||
exit 1
166 # Clean out DEST_DIR in case -noclean was passed to buildit.
169 cd $DIR/obj-llvm ||
exit 1
171 # Install the tree into the destination directory.
172 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL
=1 UNIVERSAL_ARCH
="$TARGETS" \
174 LLVM_SUBMIT_VERSION
=$LLVM_SUBMIT_VERSION \
175 LLVM_SUBMIT_SUBVERSION
=$LLVM_SUBMIT_SUBVERSION \
176 OPTIMIZE_OPTION
='-O3' VERBOSE
=1 install
178 if ! test $?
== 0 ; then
179 echo "error: LLVM 'make install' failed!"
184 RC_ProjectSourceSubversion
=`printf "%d" $LLVM_SUBMIT_SUBVERSION`
185 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include
/llvm
/Version.h
186 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include
/llvm
/Version.h
188 if [ "x$LLVM_DEBUG" != "x1" ]; then
189 # Strip local symbols from llvm libraries.
190 strip
-S $DEST_DIR$DEST_ROOT/lib
/*.
[oa
]
191 for f
in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
196 # Copy over the tblgen utility.
197 cp `find $DIR -name tblgen` $DT_HOME/local
/bin
200 cd $DEST_DIR$DEST_ROOT
201 rm -f bin
/.dir etc
/llvm
/.dir lib
/.dir
203 # Remove PPC64 fat slices.
204 cd $DEST_DIR$DEST_ROOT/bin
205 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
206 find .
-perm 755 -type f \
! \
( -name '*gccas' -o -name '*gccld' -o -name llvm-config \
) \
207 -exec lipo
-extract ppc
-extract i386
{} -output {} \
;
208 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
209 find .
-perm 755 -type f \
! \
( -name '*gccas' -o -name '*gccld' -o -name llvm-config \
) \
210 -exec lipo
-extract ppc7400
-extract i386
{} -output {} \
;
212 find .
-perm 755 -type f \
! \
( -name '*gccas' -o -name '*gccld' -o -name llvm-config \
) \
213 -exec lipo
-extract ppc7400
-extract i386
-extract x86_64
{} -output {} \
;
216 cd $DEST_DIR$DEST_ROOT
217 mkdir
-p $DT_HOME/lib
218 mv lib
/libLTO.dylib
$DT_HOME/lib
/libLTO.dylib
219 strip
-S $DT_HOME/lib
/libLTO.dylib
220 rm -f lib
/libLTO.a lib
/libLTO.la
222 # The Hello dylib is an example of how to build a pass. No need to install it.
223 rm lib
/libLLVMHello.dylib
226 MDIR
=$DEST_DIR$DEST_ROOT/share
/man
/man1
229 ################################################################################
230 # Create SYM_DIR with information required for debugging.
232 # Figure out how many make processes to run.
233 SYSCTL
=`sysctl -n hw.activecpu`
235 # hw.activecpu only available in 10.2.6 and later
236 if [ -z "$SYSCTL" ]; then
237 SYSCTL
=`sysctl -n hw.ncpu`
240 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
241 # can default to 2, since even if they are single processor, nothing else is
242 # running on the machine.
243 if [ -z "$SYSCTL" ]; then
247 cd $SYM_DIR ||
exit 1
249 # Clean out SYM_DIR in case -noclean was passed to buildit.
252 # Generate .dSYM files
253 find $DEST_DIR -perm -0111 -type f \
254 ! \
( -name '*.la' -o -name gccas
-o -name gccld
-o -name llvm-config
-o -name '*.a' \
) \
255 -print |
xargs -n 1 -P ${SYSCTL} dsymutil
257 # Save .dSYM files and .a archives
258 cd $DEST_DIR ||
exit 1
259 find . \
( -path \
*.dSYM
/\
* -or -name \
*.a \
) -print \
260 |
cpio -pdml $SYM_DIR ||
exit 1
263 mkdir
$SYM_DIR/src ||
exit 1
265 find obj-
* -name \
*.\
[chy\
] -o -name \
*.cpp
-print \
266 |
cpio -pdml $SYM_DIR/src ||
exit 1
268 ################################################################################
269 # Remove debugging information from DEST_DIR.
271 find $DEST_DIR -name \
*.a
-print |
xargs ranlib ||
exit 1
272 find $DEST_DIR -name \
*.dSYM
-print |
xargs rm -r ||
exit 1
273 chgrp
-h -R wheel
$DEST_DIR
274 chgrp
-R wheel
$DEST_DIR
276 ################################################################################
277 # Remove tar ball from docs directory
279 find $DEST_DIR -name html.
tar.gz
-exec rm {} \
;
281 ################################################################################